% Nom du fichier : post_traitement.m
% 
% Appel de la fonction :
% 
% DESCRIPTION GENERALE
% 
% DESCRITPION DES ENTREES DE LA FONCTION
%
% DESCRIPTION DES SORTIES DE LA FONCTION
% 
% EXEMPLE MATLAB D APPEL DE LA FONCTION
%
%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm

function post_traitement(Ux,Uy,Fx,Fy,Tc,te,Tnn,E,Nu,X,Y,ne)

nn(1)=size(Tnn,2);
nn(2)=size(Tnn,1);
ne = nn-1;
nnt = prod(nn);
net=prod(ne);

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Post-traitement :
% disp(' Post-traitement :');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul des dformations :
% disp('        -> Calcul des dformations en chacun des noeuds...')
%
% Pour le calul des dfomrations au milieu des lments, on utilise la table de
% connectivit qui dit que tel lment est rattach  tel noeud, ce qui permet d'aller
% chercher ds les tableaux de dplacements les dplacements nodaux de
% chacun des noeuds.
% 
% Pour chaque lment on calcul les dformations au milieu de chacun des
% lments et en chacun des noeuds. On calcul aussi la dformation moyenne
% en chacun des noeuds (c'est pour grediac).
% 
% Pour chacun de ces calculs, on utilise la fonction fctB, qui lie les dplacements
% nodaux aux dformations correspondantes en un point de l'lment concern,
% grace  une matrice.
% 

% Dformations moyenne en chaque noeud :
defosmoy=zeros(3,nnt);
indices_pour_defomoyenne=zeros(3,nnt);

%Uelem=zeros(8,1);
for numero_elem=1:1:net
    Uelem=[Ux(Tc(numero_elem,1));
           Uy(Tc(numero_elem,1));
           Ux(Tc(numero_elem,2));
           Uy(Tc(numero_elem,2));
           Ux(Tc(numero_elem,3));
           Uy(Tc(numero_elem,3));
           Ux(Tc(numero_elem,4));
           Uy(Tc(numero_elem,4))];
    
    % Dformations moyenne en chaque noeud :
    defosmoy(:,Tc(numero_elem,1))=defosmoy(:,Tc(numero_elem,1))+fctB(0,0,te(1),te(2))*Uelem;
    defosmoy(:,Tc(numero_elem,2))=defosmoy(:,Tc(numero_elem,2))+fctB(te(1),0,te(1),te(2))*Uelem;
    defosmoy(:,Tc(numero_elem,3))=defosmoy(:,Tc(numero_elem,3))+fctB(te(1),te(2),te(1),te(2))*Uelem;
    defosmoy(:,Tc(numero_elem,4))=defosmoy(:,Tc(numero_elem,4))+fctB(0,te(2),te(1),te(2))*Uelem;
    for pp=1:1:4
        indices_pour_defomoyenne(:,Tc(numero_elem,pp))=indices_pour_defomoyenne(:,Tc(numero_elem,pp))+[1;1;1];
    end
    
end
clear numero_elem Uelem pp

% Moyenne des dfos en chaque noeud :
defosmoy=defosmoy./indices_pour_defomoyenne;
clear indices_pour_defomoyenne

% Mise en forme pour le graphe :
deformations.Exx_moyen=reshape(defosmoy(1,:),nn(1),nn(2)); %'
deformations.Eyy_moyen=reshape(defosmoy(2,:),nn(1),nn(2)); %'
deformations.Es_moyen=reshape(defosmoy(3,:),nn(1),nn(2)); %'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OPTIONNEL !
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul des dformations principales  partir des dformations moyennes en
% chaque noeuds 
deformations.princ1 = zeros(1,nnt);
deformations.princ2 = zeros(1,nnt);
deformations.dir1 = zeros(2,nnt);
deformations.dir2 = zeros(2,nnt);
for numero_noeud=1:1:nnt
    
    % Tenseur des deformations :
    Tdefo(1,1)=defosmoy(1,numero_noeud);
    Tdefo(2,2)=defosmoy(2,numero_noeud);
    Tdefo(1,2)=defosmoy(3,numero_noeud);
    Tdefo(2,1)=Tdefo(1,2);
    
    % Diagonalisation du tenseur :
    [V,D]=eig(Tdefo,'nobalance');
    deformations.princ1(numero_noeud)=D(1,1);
    deformations.princ2(numero_noeud)=D(2,2);
    deformations.dir1(:,numero_noeud)=V(:,1);
    deformations.dir2(:,numero_noeud)=V(:,2);
    
end
deformations.princ1 = reshape(deformations.princ1,nn(1),nn(2));
deformations.princ2 = reshape(deformations.princ2,nn(1),nn(2));
deformations.dir1x = reshape(deformations.dir1(1,:),nn(1),nn(2));
deformations.dir1y = reshape(deformations.dir1(2,:),nn(1),nn(2));
deformations.dir2x = reshape(deformations.dir2(1,:),nn(1),nn(2));
deformations.dir2y = reshape(deformations.dir2(2,:),nn(1),nn(2));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OPTIONNEL !
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul des contraintes :
% disp('        -> Calcul des contraintes en chacun des noeuds, pour chaque lment et pour chaque composante...')
% Matrice constitutive matriau :
contraintes.n1=zeros(3,net);
contraintes.n2=zeros(3,net);
contraintes.n3=zeros(3,net);
contraintes.n4=zeros(3,net);

for numero_elem=1:1:net
    
    % Matrice constitutive dpendente du numero de l'lment :
    % Dpend si on est en contraintes planes ou en dformations planes.
    %  alpha1 = 1 => dformation planes, alpha1 = 0 => contraintes planes !
    alpha1 = 1;
    D_constitutive = E(numero_elem)/((1+Nu)*(1-Nu-alpha1*Nu))*[1-alpha1*Nu Nu 0;Nu 1-alpha1*Nu 0;0 0 (1-Nu-alpha1*Nu)/2];
    
    % Calcul des contraintes :
    contraintes.n1(:,numero_elem)= D_constitutive*defosmoy(:,Tc(numero_elem,1));
    contraintes.n2(:,numero_elem)= D_constitutive*defosmoy(:,Tc(numero_elem,2));
    contraintes.n3(:,numero_elem)= D_constitutive*defosmoy(:,Tc(numero_elem,3));
    contraintes.n4(:,numero_elem)= D_constitutive*defosmoy(:,Tc(numero_elem,4));
    
end

% Mise en forme pour le graphe :
contraintes.Sxx=reshape(contraintes.n1(1,:),ne(1),ne(2))';
contraintes.Syy=reshape(contraintes.n1(2,:),ne(1),ne(2))';
contraintes.Sxy=reshape(contraintes.n1(3,:),ne(1),ne(2))';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OPTIONNEL !
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Organisation de M_Ux, M_Uy, M_Fx et M_Fy  partir de Ux, Uy, Fx et Fy :
M_Ux=reshape(Ux,nn(1),nn(2));
M_Uy=reshape(Uy,nn(1),nn(2));
M_Fx=reshape(Fx,nn(1),nn(2));
M_Fy=reshape(Fy,nn(1),nn(2));
new_X=X+M_Ux;
new_Y=Y+M_Uy;

% On peut ici calculer la norme du dplacement, pour tudier la
% convergence.
save(['U_',num2str(ne(1))],'M_Ux','M_Uy','M_Fx','M_Fy');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % % Trac de la dforme :
% % % disp('        -> Trac de la dforme...')
% % % figure
% % % plot(X,Y,'b.')
% % % hold on
% % % plot(new_X,new_Y,'r.')
% % % grid on


% % % % Trac en couleur de la dforme :
% % % figure('Name','Trac de la dforme. Echelle des couleurs reprsentant Ux')
% % % surf(new_X,new_Y,M_Ux,M_Ux);
% % % %hold on
% % % %surf(X,Y,min(min(M_Ux+M_Uy))*ones(size(X)));
% % % view(0,90)
% % % axis equal
% % 

% figure('Name','Trac de la dforme. Echelle des couleurs reprsentant Uy')
% surf(new_X,new_Y,ones(size(M_Uy)),'Marker','.'); % M_Uy); %,M_Uy);
% %%hold on
% %%surf(X,Y,min(min(M_Ux+M_Uy))*ones(size(X)));
% view(0,90)
% axis equal


% Trac des dformations :
% disp('        -> Trac des dformations...')
% figure('Name','Trac des dformations Exx en chacun des noeuds en les moyennant.')
% % surf(new_X,new_Y,deformations.Exx_moyen,deformations.Exx_moyen);
% % surf(X,Y,deformations.Exx_moyen,deformations.Exx_moyen);
% % view(0,90)
% plot([0,1],[0,1]); hold on
% imagesc(deformations.Exx_moyen);
% axis equal
% % 
figure('Name','Trac des dformations Eyy en chacun des noeuds en les moyennant.')
%surf(new_X,new_Y,deformations.Eyy_moyen,deformations.Eyy_moyen,'Marker','none','FaceColor','interp','LineStyle','none');
surf(new_X,new_Y,deformations.Eyy_moyen,'FaceColor','interp');
axis equal
view(2)
%view(0,90)
%colorbar;

% 
% 
% % Trac des dformations principales :
% disp('        -> Trac des dformations principales...')
% 
% % figure('Name','Trac des dformations principales1 en chacun des noeuds en les moyennant.')
% % surf(X,Y,deformations.princ1-2*max(max(deformations.princ1)),deformations.princ2);
% % colormap('gray')
% % hold on
% % quiver(X,Y,deformations.dir1x,deformations.dir1y,0.25,'g')
% % quiver(X,Y,-deformations.dir1x,-deformations.dir1y,0.25,'g')
% % view(2)
% % % axis equal
% 
% % figure('Name','Trac des dformations principales2 en chacun des noeuds en les moyennant.')
% % surf(X,Y,deformations.princ2-2*max(max(deformations.princ2)),deformations.princ2);
% % colormap('gray')
% % hold on
% % quiver(X,Y,deformations.dir2x,deformations.dir2y,0.25,'g')
% % quiver(X,Y,-deformations.dir2x,-deformations.dir2y,0.25,'g')
% % view(2)
% % % axis equal


% % Trac des contrinates :
% disp('        -> Trac des contraintes...')
% 
% figure('Name','Trac des contraintes Sxx en chacun des noeuds en les moyennant.')
% surf(contraintes.Syy,'Marker','.');
% view(0,90)
% % axis equal
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%


end